=== modified file 'src/com/goldencode/p2j/ui/chui/ThinClient.java'
--- src/com/goldencode/p2j/ui/chui/ThinClient.java	2022-03-10 21:22:31 +0000
+++ src/com/goldencode/p2j/ui/chui/ThinClient.java	2022-03-13 18:36:16 +0000
@@ -2784,6 +2784,8 @@
 **     HC  20220228          Prevented client abend when error in loading image data.
 **     CA  20220304          In putBrowseColumnValues, log if attempting to use a BROWSE column with an invalid
 **                           ID (set to -1).
+**     VVT 20220306          Method processProgressEvent: results of calls to event.id(), and event.source() extracted
+**                           to local variables (otherwise these calls are performed >40 times in the method code).
 **     SBI 20220311          openMimeResource should accept spaces and escaped spaces for local file resources.
 */
 
@@ -19582,11 +19584,13 @@
     */
    public void processProgressEvent(Event event)
    {
+      int evtId = event.id();
+      Widget eventSource = event.source();
+      
       if (event instanceof ResourceEvent)
       {
          ResourceEvent revt = (ResourceEvent) event;
          
-         int evtId = revt.id();
          long resourceId = revt.resourceId();
          boolean foundGo = false;
          if (checkBreak(resourceId, evtId))
@@ -19599,7 +19603,7 @@
          boolean consume = false;
          try
          {
-            TriggerResult tr = invokeTriggers(event.source(), resourceId, evtId, false);
+            TriggerResult tr = invokeTriggers(eventSource, resourceId, evtId, false);
             consume = tr.consume;
          }
          finally
@@ -19626,7 +19630,7 @@
          }
 
          boolean comEvent = srv.getName().equals("COM-EVENT");
-         Runnable serverCode = () -> invokeOnServer(() -> server.invokeServerEvent(srv.id()));
+         Runnable serverCode = () -> invokeOnServer(() -> server.invokeServerEvent(evtId));
          
          if (comEvent)
          {
@@ -19644,17 +19648,18 @@
       {
          MouseEvt evt = (MouseEvt) event;
          
+         MouseEvent awtEvent = evt.getEvent();
+         int eventType = awtEvent.getID();
          if (consumeNextMouseClick)
          {
             // this flag is set only on a mouse released event.  only the next clicked event must be consumed.
-            int evtID = evt.getEvent().getID();
-            if (evtID == MouseEvt.MOUSE_PRESSED  || 
-                evtID == MouseEvt.MOUSE_RELEASED ||
-                evtID == MouseEvt.MOUSE_CLICKED)
+            if (eventType == MouseEvt.MOUSE_PRESSED  || 
+                eventType == MouseEvt.MOUSE_RELEASED ||
+                eventType == MouseEvt.MOUSE_CLICKED)
             {
                consumeNextMouseClick = false;
 
-               if (evtID == MouseEvt.MOUSE_CLICKED)
+               if (eventType == MouseEvt.MOUSE_CLICKED)
                {
                   // consume this - it will be raised explicitly
                   evt.consume();
@@ -19663,7 +19668,10 @@
             }
          }
          
-         Function<Widget, Boolean> hasWindow = (w) ->
+         // apply the event
+         TopLevelWindow window = (TopLevelWindow) eventSource;
+         
+         Function<Widget, Boolean> hasWindow = w ->
          {
             if (w != null)
             {
@@ -19678,22 +19686,17 @@
             return true;
          };
          
-         // apply the event
-         TopLevelWindow window = (TopLevelWindow) evt.source();
-         
          if (!hasWindow.apply(window))
          {
             // the window has been destroyed
             return;
          }
 
-         Widget<?> mouseSource = evt.getExplicitSource();
-
-         if (mouseSource == null)
-         {
-            mouseSource = window.findMouseSource(evt);
-         }
-
+         // Note: we effectively ignore the value provided by the driver here,
+         // to restore using driver events, replace window.findMouseSource(evt) back
+         // to evt.getExplicitSource()
+         Widget<?> mouseSource = window.findMouseSource(evt);
+       
          if (mouseSource == null)
          {
             mouseSource = window;
@@ -19750,18 +19753,16 @@
          boolean maySwitchFocusDown = false;
          boolean maySwitchFocusUp = false;
          
-         // get the mouse event type
-         int evtID = evt.getEvent().getID();
          // exclude mouse move events from consideration
-         if (evtID == MouseEvt.MOUSE_PRESSED  ||
-             evtID == MouseEvt.MOUSE_RELEASED ||
-             evtID == MouseEvt.MOUSE_CLICKED)
+         if (eventType == MouseEvt.MOUSE_PRESSED  ||
+             eventType == MouseEvt.MOUSE_RELEASED ||
+             eventType == MouseEvt.MOUSE_CLICKED)
          {
             maySwitchFocusDown = mouseSource != null &&
-                                 evtID == MouseEvt.MOUSE_PRESSED &&
+                                 eventType == MouseEvt.MOUSE_PRESSED &&
                                  mouseSource.maySwitchFocus();
             maySwitchFocusUp   = mouseSource != null &&
-                                 evtID == MouseEvt.MOUSE_RELEASED &&
+                                 eventType == MouseEvt.MOUSE_RELEASED &&
                                  mouseSource.maySwitchFocus();
             
             if (mouseSource != null && !mouseSource.isRMBEntrySupported())
@@ -19776,16 +19777,16 @@
          // from here on, we need to work with the browse
          if (legacyMouseSource != null && legacyMouseSource.parent(Browse.class) != null)
          {
-            if (!isChui() && (evtID == MouseEvt.MOUSE_CLICKED ||
-                              evtID == MouseEvt.MOUSE_PRESSED ||
-                              evtID == MouseEvt.MOUSE_RELEASED))
+            if (!isChui() && (eventType == MouseEvt.MOUSE_CLICKED ||
+                              eventType == MouseEvt.MOUSE_PRESSED ||
+                              eventType == MouseEvt.MOUSE_RELEASED))
             {
                // GUI browse click case.
                if (legacyMouseSource instanceof FillIn ||
                    legacyMouseSource instanceof ComboBox)
                {
                   // BrowseColumn is the legacyMouseSource
-                  legacyMouseSource = legacyMouseSource.getTriggerWidget(evtID, evt.isRealKey());
+                  legacyMouseSource = legacyMouseSource.getTriggerWidget(eventType, evt.isRealKey());
                }
                else if (legacyMouseSource instanceof ToggleBox)
                {
@@ -19800,7 +19801,7 @@
                   else
                   {
                      // BrowseColumn is the legacyMouseSource
-                     legacyMouseSource = legacyMouseSource.getTriggerWidget(evtID, evt.isRealKey());
+                     legacyMouseSource = legacyMouseSource.getTriggerWidget(eventType, evt.isRealKey());
                   }
                }
                else if (!mouseSource.raiseLegacyMouseEvents())
@@ -19810,11 +19811,11 @@
                else if (legacyMouseSource instanceof BrowseColumn)
                {
                   BrowseGuiImpl browse = (BrowseGuiImpl) legacyMouseSource.parent(Browse.class);
-                  if (evtID == MouseEvt.MOUSE_PRESSED ||
-                      evtID == MouseEvt.MOUSE_RELEASED ||
+                  if (eventType == MouseEvt.MOUSE_PRESSED ||
+                      eventType == MouseEvt.MOUSE_RELEASED ||
                       !evt.isLeftButton() ||
                       ((BrowseColumn) legacyMouseSource).config().readOnly ||
-                      browse.isBelowLastRow(evt.getEvent()))
+                      browse.isBelowLastRow(awtEvent))
                   {
                      legacyMouseSource = browse;
                   }
@@ -19830,7 +19831,7 @@
                legacyMouseSource = legacyMouseSource.parent(Browse.class);
             }
          }
-         else if (legacyMouseSource instanceof BrowseGuiImpl && evtID == MouseEvt.MOUSE_CLICKED)
+         else if (legacyMouseSource instanceof BrowseGuiImpl && eventType == MouseEvt.MOUSE_CLICKED)
          {
             // If we click on the empty area to the right of the rightmost column which is an editing column,
             // editing is started and the trigger for this rightmost column is invoked.
@@ -19940,12 +19941,12 @@
          
          if (evt.isLeftButton())
          {
-            if (evtID == MouseEvt.MOUSE_PRESSED)
+            if (eventType == MouseEvt.MOUSE_PRESSED)
             {
                downMouseButtonNewFocus = newFocus;
                downMouseButtonOldFocus = oldFocus;
             }
-            else if (evtID == MouseEvt.MOUSE_RELEASED)
+            else if (eventType == MouseEvt.MOUSE_RELEASED)
             {
                if (downMouseButtonNewFocus != null && !downMouseButtonNewFocus.hasFocus())
                {
@@ -20106,15 +20107,13 @@
       if (event instanceof PortableMouseEvent || event instanceof WindowEvent)
       {
          // set the event details
-         int evtId = event.id();
-         
          functionKey = event instanceof WindowEvent ? ((WindowEvent) event).getAction()
                                                     : ((PortableMouseEvent) event).getAction();
          
-         Widget<?> src = event.source();
+         Widget<?> src = eventSource;
          
          WidgetId id = src.getId();
-         if (src != null && id != null && WidgetId.virtualWidget(id))
+         if (id != null && WidgetId.virtualWidget(id))
          {
             // virtual widgets do not call mouse triggers
          }
@@ -20147,11 +20146,11 @@
             
             lastKeyState = 0;
 
-            TriggerResult tr = invokeTriggers(event.source(), evtId, false, eventX, eventY);
+            TriggerResult tr = invokeTriggers(eventSource, evtId, false, eventX, eventY);
             boolean consumed = tr.consume;
             if (functionKey != -1 && functionKey != evtId)
             {
-               tr = invokeTriggers(event.source(), functionKey, false, eventX, eventY);
+               tr = invokeTriggers(eventSource, functionKey, false, eventX, eventY);
                consumed = consumed || tr.consume;
             }
             
@@ -20162,8 +20161,8 @@
             }
 
             // check if we have mouse event attached exit conditions
-            if (checkBreak(event.source(), evtId, false) ||
-                (functionKey != -1 && checkBreak(event.source(), functionKey, false)))
+            if (checkBreak(eventSource, evtId, false) ||
+                (functionKey != -1 && checkBreak(eventSource, functionKey, false)))
             {
                addGoPending();
             }
@@ -20180,27 +20179,27 @@
       
       if (event instanceof WindowActivated)
       {
-         event.source().processEvent(event);
+         eventSource.processEvent(event);
          return;
       }
 
       // direct manipulation events calls the handler from source
       if (event instanceof DirectManipulationEvent)
       {
-         boolean invokeBefore = event.id() == Keyboard.SE_END_MOVE;
+         boolean invokeBefore = evtId == Keyboard.SE_END_MOVE;
          if (invokeBefore)
          {
             // for buttons invoke immediately
-            event.source().processDirectManipulationEvent((DirectManipulationEvent)event);
+            eventSource.processDirectManipulationEvent((DirectManipulationEvent)event);
          }
          
          // execute registered triggers first
-         TriggerResult tr = invokeTriggers(event.source(), event.id(), false);
+         TriggerResult tr = invokeTriggers(eventSource, evtId, false);
          
          Integer aliasId = ((DirectManipulationEvent) event).getAlias();
          if (!tr.executed && aliasId != null)
          {
-            tr = invokeTriggers(event.source(), aliasId, false);
+            tr = invokeTriggers(eventSource, aliasId, false);
          }
          
          if (!invokeBefore)
@@ -20208,19 +20207,19 @@
             // if not consumed then invoke event handler
             if (!tr.consume)
             {
-               event.source().processDirectManipulationEvent((DirectManipulationEvent)event);
+               eventSource.processDirectManipulationEvent((DirectManipulationEvent)event);
             }
             // if consumed(NO-APPLY defined) inform handler about consumed event
             else if (((DirectManipulationEvent)event).hasHandler())
             {
-               ((DirectManipulationEvent)event).getHandler().setNoApplyEvent(event.id());
+               ((DirectManipulationEvent)event).getHandler().setNoApplyEvent(evtId);
             }
          }
          return;
       }
       
       KeyInput evt    = (event instanceof KeyInput ? (KeyInput) event : null);
-      Widget   src    = event.source().getTriggerWidget();
+      Widget   src    = eventSource.getTriggerWidget();
       int      key      = (evt == null ? KeyInput.CHAR_UNDEFINED : evt.keyCode());
       int      keyState = (evt == null ? 0 : evt.getKeyState());
       int      action   = (evt == null ? KeyInput.CHAR_UNDEFINED  : evt.actionCode());

=== modified file 'src/com/goldencode/p2j/ui/client/TopLevelWindow.java'
--- src/com/goldencode/p2j/ui/client/TopLevelWindow.java	2022-02-15 12:19:45 +0000
+++ src/com/goldencode/p2j/ui/client/TopLevelWindow.java	2022-03-09 23:24:54 +0000
@@ -65,6 +65,11 @@
 **                  See #6013.
 **     VVT 20220215 Change 13474 for #6013 temporary reverted (caused multiple regressions,
 **                  need to be completed).
+**     VVT 20220306 A new private field mousePressedSource was introduced. This field remembers the widget
+**                  the mouse was pressed upon, and the value is used as the mouse event target during drag
+**                  operation. findMouseSource(MouseEvt) implementation added. It uses
+**                  mousePressedSource for drag operations, otherwise calls
+**                  findMouseSource(evtID, mousePoint). See #6013.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -127,7 +132,6 @@
 import com.goldencode.p2j.ui.*;
 import com.goldencode.p2j.ui.chui.*;
 import com.goldencode.p2j.ui.client.event.*;
-import com.goldencode.p2j.ui.client.event.FocusEvent;
 import com.goldencode.p2j.ui.client.gui.*;
 import com.goldencode.p2j.ui.client.gui.driver.*;
 import com.goldencode.p2j.ui.client.gui.theme.*;
@@ -215,16 +219,33 @@
    }
    
    /**
-    * Get the title bar widget associated witn this window.
+    * Get the title bar widget associated with this window.
     * 
     * @return   See above.
     */
+   @SuppressWarnings("static-method")
    public WindowTitleBar getTitleBar()
    {
       return null;
    }
 
    /**
+    * Find the widget to which the given mouse event can be applied.
+    * 
+    * @param    evt
+    *           The mouse event.
+    * 
+    * @return   A widget over which the mouse is positioned or {@code null} if none found.
+    */
+   public final Widget<O> findMouseSource(MouseEvt evt)
+   {
+      int evtID = evt.getEvent().getID();
+      java.awt.Point p = evt.getEvent().getPoint();
+      Widget<O> mouseSource = findMouseSource(evtID, new NativePoint(p.x, p.y));
+      return (mouseSource == null ? this : mouseSource);
+   }
+
+   /**
     * Sets the default window icon for all new windows on the client side.
     * 
     * @param    type
@@ -652,6 +673,7 @@
     *
     * @return   <code>TRUE</code> if operation successful <code>FALSE</code> otherwise.
     */
+   @SuppressWarnings("static-method")
    public boolean setWindowIcon(byte[] newIcon)
    {
       // this is generic and CHUI version returning false
@@ -668,6 +690,7 @@
     *
     * @return   <code>TRUE</code> if operation successful <code>FALSE</code> otherwise.
     */
+   @SuppressWarnings("static-method")
    public boolean setWindowIcon(boolean small, byte[] newIcon)
    {
       // this is generic and CHUI version returning false
@@ -684,6 +707,7 @@
     *
     * @return   <code>TRUE</code> if operation successful <code>FALSE</code> otherwise.
     */
+   @SuppressWarnings("static-method")
    public boolean loadWindowIcon(boolean small, String name)
    {
       // this is generic and CHUI version returning false
@@ -705,6 +729,7 @@
     * 
     * @return   This implementation always returns <code>false</code>.
     */
+   @SuppressWarnings("static-method")
    public boolean isMaximized()
    {
       return false;
@@ -715,6 +740,7 @@
     *
     * @return   If minimized returns <code>true</code>, <code>false</code> otherwise.
     */
+   @SuppressWarnings("static-method")
    public boolean isMinimized()
    {
       return false;

=== modified file 'src/com/goldencode/p2j/ui/client/UiUtils.java'
--- src/com/goldencode/p2j/ui/client/UiUtils.java	2022-03-10 21:22:31 +0000
+++ src/com/goldencode/p2j/ui/client/UiUtils.java	2022-03-13 18:35:35 +0000
@@ -425,7 +425,7 @@
     * @param    w
     *           Component to for which ID is requested.
     * 
-    * @return   The widget ID or {@code null} if the widget doesn't have a config.
+    * @return   The widget ID or {@code null}.
     */
    public static WidgetId getWidgetId(Widget<?> w)
    {
@@ -438,7 +438,7 @@
     * @param    widget
     *           Component to for which ID is requested.
     * 
-    * @return   The widget ID or -1 if the widget doesn't have a config.
+    * @return   The widget ID or -1 if widget is {@code null}
     */
    static public int getWidgetIdAsInt(Widget<?> widget)
    {

=== modified file 'src/com/goldencode/p2j/ui/client/WindowManager.java'
--- src/com/goldencode/p2j/ui/client/WindowManager.java	2022-03-10 01:16:48 +0000
+++ src/com/goldencode/p2j/ui/client/WindowManager.java	2022-03-13 18:36:38 +0000
@@ -2,7 +2,7 @@
 ** Module   : WindowManager.java
 ** Abstract :
 **
-** Copyright (c) 2010-2021, Golden Code Development Corporation.
+** Copyright (c) 2010-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description----------------------------------
 ** 001 SIY 20100629 Created initial version
@@ -127,6 +127,14 @@
 **                  have a caret, be highlighted, etc.
 **     SVL 20220209 Generate frame LEAVE event when another window receives the focus.
 **     VVT 20220218 Javadocs and other cosmetic fixes.
+**     VVT 20220306 getNextActiveWindow code refactored, so compilator complains of "Unlikely argument type"
+**                  no more. processWindowEvent: the mouse source stored with the event by the driver
+**                  used instead of running window.findMouseSource(evt) second time.  Note: after this
+**                  change, the call to findMouseSource is executed only once by the driver (previously
+**                  findMouseSource was called multiple times during the event dispatching and processing,
+**                  which is waste of CPU time, and probably may result in incorrect returned value).
+**                  Local variable parent renamed to mouseSourceWithId, since the old name was misleading.
+**                  See #6013.
 **     EVL 20220309 Dialog box window should ensure the focus to be requested for activation case.
 */
 /*
@@ -215,6 +223,7 @@
    private static final ContextLocal<WorkArea> work = 
    new ContextLocal<WorkArea>()
    {
+      @Override
       protected synchronized WorkArea initialValue()
       {
          return new WorkArea();
@@ -1259,7 +1268,7 @@
          }
          
          Map<GuiWindow, Set<TopLevelWindow>> delayed = wa.delayedMinimizeWindows;
-         delayed.remove(window);
+         delayed.remove((Object)window);
          for (Set<TopLevelWindow> v : delayed.values())
          {
             v.remove(window);
@@ -1812,17 +1821,18 @@
    {
       Predicate<TitledWindow<?>> checkNextWindow = tw ->
       {
-         if (!tw.isVisible()                               ||
-             !(tw instanceof GuiWindow)                    ||
-             ((GuiWindow) tw).isShareActivationWithOwner() ||
-             ((GuiWindow) tw).isMinimized()                ||
-             tw.equals(hidingWindow))
+         if (!tw.isVisible() || !(tw instanceof GuiWindow))
          {
             return false;
          }
          
-         return true;
+         GuiWindow guiWindow = (GuiWindow) tw;
+         
+         return !guiWindow.isShareActivationWithOwner() &&
+                !guiWindow.isMinimized()                &&
+                !guiWindow.equals(hidingWindow);
       };
+      
       if (!isIconifying)
       {
          ArrayList<Window<?>> list = work.get().currentWindowsStack;
@@ -1915,26 +1925,22 @@
       {
          MouseEvt evt = (MouseEvt) event;
          
-         Widget<?> mouseSource = (Widget<?>) evt.getExplicitSource();
-         if (mouseSource == null)
-         {
-            mouseSource = window.findMouseSource(evt);
-         }
+         Widget<?> mouseSource = evt.getExplicitSource();
          
          if (mouseSource != null && mouseSource.isDisplayed())
          {
             // search for a parent with a valid id
-            Widget<?> parent = WidgetRegistry.findAncestor(mouseSource,
+            Widget<?> mouseSourceWithId = WidgetRegistry.findAncestor(mouseSource,
                                                            t -> UiUtils.getWidgetId(t) != null);
             
-            WidgetId id = (parent != null) ? parent.getId() : null;
+            WidgetId id = (mouseSourceWithId != null) ? mouseSourceWithId.getId() : null;
             
-            if (id != null && parent.ancestor() != null)
+            if (id != null && mouseSourceWithId.ancestor() != null)
             {
                // not all OS-widgets have an ID, skip those
                GuiDriver gd = (GuiDriver) OutputManager.getDriver();
                
-               gd.selectWindow(parent.topLevelWindow().getId().asInt());
+               gd.selectWindow(mouseSourceWithId.topLevelWindow().getId().asInt());
                try
                {
                   gd.handleMouseEvent(id.asInt(), evt.getEvent());

